
<?php
// ------------------------------------------------------------------------- //
// Coppermine Backup v0.2                                                        //
// ------------------------------------------------------------------------- //
// Copyright (C) 2005 Jeff Paffett                                           //
// http://www.lesvosisland.com                                               //
// ------------------------------------------------------------------------- //
// This program is free software; you can redistribute it and/or modify      //
// it under the terms of the GNU General Public License as published by      //
// the Free Software Foundation; either version 2 of the License, or         //
// (at your option) any later version.                                       //
// ------------------------------------------------------------------------- //

//Avoid problems with max_execution_time on Windows
@set_time_limit(0);

require ('include/config.inc.php');
require ('include/backup.inc.php');

//function to write header
function html_header()
{

    ?>
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Coppermine - Backup</title><link type="text/css" rel="stylesheet" href="installer.css">
</head>
<body>
 <div align="center">
  <div style="width:100%;">
<table class="maintable">
    <tr>
      <th class="tableh1">Performing Backups</th>
    </tr>
<?php
}

//Coppermine logo function
function html_logo()
{

    ?>
      <table width="100%" border="0" cellpadding="0" cellspacing="1" class="maintable">
       <tr>
        <td valign="top" bgcolor="#EFEFEF"><img src="images/logo.gif"><br />
        </td>
       </tr>
      </table>
      <table>
<?php
}

//Function to write footer
function html_footer()
{

    ?>
    </table>
    </table>
    </table>
  </div>
 </div>
</body>
</html>
<noscript><plaintext>
<?php
}

//function to create directories where needed and call getfiles
function getdirectories($item2)
{
global $conn_id, $local_photos, $server_photos, $curdir;

	$curdir = $item2;
	
	//filter /. and /.. records
	if ($curdir != '.' && $curdir != '..')
	{
	
	if (!file_exists($local_photos.$curdir))
		{
		mkdir($local_photos.$curdir);
		}

		//Retrieve array of directories in albums
		$file_array = ftp_nlist($conn_id,$server_photos.$item2);
	
		//Call getfiles for each element in array
		array_walk($file_array, 'getfiles');
	}
}


//Function to retrieve files from ftp server
function getfiles($item2)
{

global $conn_id, $local_photos, $server_photos, $curdir;

$local_file = $local_photos.$curdir.'/'.$item2;
$server_file = $server_photos.$curdir.'/'.$item2;

//Check if file already exists on local system and if not transfer it
if (!file_exists($local_file)) 
	{
	if (ftp_get($conn_id, $local_file, $server_file, FTP_BINARY)) 
		{
		echo "<tr><td class='tableb'>File saved to $local_file</td></tr>";
		} 
		else 
		{
		echo "<tr><td class='tableb'>There was a problem writing $local_file</td></tr>";
		}
	}

}

html_logo();
html_header();

//Write initial command string
$cmdstring = $mysql_path.'mysqldump --opt -h '.$remdbHost.' -u'.$remdbUser.' -p'.$remdbPass.' '.$remdbName.' ';

if (@mysql_connect($remdbHost,$remdbUser,$remdbPass))
	{
	echo "<tr><td class='tableb'>Backing up database</td></tr>";
	echo "<tr><td class='tableb'>Connected to server $remdbHost</td></tr>";
	
	mysql_select_db($remdbName);
	
	$q = mysql_query("SHOW TABLES");
	
	$numrows = mysql_num_rows($q);
			
	//Step through tables in remote db and if they match
	//cpg table prefix add to command string
	for ($i=0; $i <$numrows; $i++)
		{
		$row = mysql_fetch_array($q);
		
		if (substr($row[0],0,strlen($CONFIG['TABLE_PREFIX'])) == $CONFIG['TABLE_PREFIX'])
			{
			$cmdstring .= $row[0]." ";
			}
		}
	
	//Finish command string and call mysqldump
	$cmdstring .= ' > '.$dest.$backupfile;
		
	system($cmdstring.$error);
	
	if ($error)
		{
		echo $error;
		}
		else
		{
		echo "<tr><td class='tableb'>Database backed up to ".$dest.$backupfile.'</td></tr>';
		}
	
	//Restore backup file to local db
	system($mysql_path.'mysql -u'.$CONFIG['dbuser'].' -p'.$CONFIG['dbpass'].' '.$CONFIG['dbname'].' < '.$dest.$backupfile);
	echo "<tr><td class='tableb'>Database restored to local database: ".$CONFIG['dbname']."</td></tr>";
	}
	else
	{
	echo "<tr><td class='tableb'>Couldn't connect to server $remdbHost</td></tr>";
	}

//Connect to ftp server
$conn_id = ftp_connect($ftp_server) or die("Couldn't connect to $ftp_server"); 


if (@ftp_login($conn_id, $ftp_user, $ftp_pass)) 
	{
	echo "<tr><td class='tableb'>Backing up files</td></tr>";
	echo "<tr><td class='tableb'>Connected to ftp server as $ftp_user@$ftp_server</td></tr>";
	
	//Retrieve array of files in userpics 
	$file_array = ftp_nlist($conn_id,$server_photos);

	//Call getfiles for each element in array
	array_walk($file_array, 'getdirectories');
	
	echo "<tr><td class='tableb'>All files backed up</td></tr>";
	}
	else
	{
	echo "<tr><td class='tableb'>Couldn't connect as $ftp_user</td></tr>";
	}
	
// close the connection
ftp_close($conn_id);

html_footer();

?>